// FunctionParser.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <math.h>

#include "Collect.h"
#include "mathutil.h"
#include "Vektor.h"
#include "FktParser.h"
#include "Mathstr.h"


int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	CStdString strResult;

	// Read in a valid expression (math. term)
	CStdString Expression;
	TCHAR buffer[255];
	_tprintf(_T("f(x)="));
	_tscanf(_T("%s"), buffer);
	Expression = buffer;
	// Parse it and get the function tree
	CFunction<long double>* fkt = CFunction<long double>::Parse(Expression);
	if (fkt)
	{
		// Read in the argument
		long double x;
    float f;
		_tprintf(_T("x="));
		_tscanf(_T("%f"), &f);
    x = f;

		// Display results
		long double y = fkt->Execute(x);
		strResult.Format(_T("Expression=%s  f(%Lf)=%Lf"), (LPCTSTR)Expression, x, y);
		_tprintf(_T("%s\n"), (LPCTSTR)strResult);
		CStdString ExpressionParsed = fkt->GetName();
		strResult.Format(_T("Expression (parsed)=%s"), (LPCTSTR)ExpressionParsed);
		_tprintf(_T("%s\n"), (LPCTSTR)strResult);
		CFunction<long double>* df = fkt->GetDerivate();
		if (df)
		{
			long double dy = df->Execute(x);
			CStdString ExpressionDerived = df->GetName();
			strResult.Format(_T("Expression (derivate)=%s  f'(%Lf)=%Lf"), (LPCTSTR)ExpressionDerived, x, dy);
			_tprintf(_T("%s\n"), (LPCTSTR)strResult);
			delete df;
		}

    delete fkt;
	}
	else
	{
		strResult.Format(_T("Expression=%s  Error"), (LPCTSTR)Expression);
		_tprintf(_T("%s\n"), (LPCTSTR)strResult);
	}
}


